#
# This file is licensed under the GNU General Public License, Version 2.
#

#
# Default Jython environment preparation script for Schmant builds.
#

#
# FUNCTIONS THAT SCRIPTS CAN USE
#

def debug(s):
	if s == None:
		s = '<None>'
	ReportManager.getReport().debug(s)

def info(s):
	if s == None:
		s = '<None>'
	ReportManager.getReport().info(s)

def warn(s):
	if s == None:
		s = '<None>'
	ReportManager.getReport().warn(s)

def error(s):
	if s == None:
		s = '<None>'
	ReportManager.getReport().error(s)

def fail(s):
	if s == None:
		s = '<None>'
	ReportManager.getReport().error(s)
	raise SchmantException(s)

#
# Import all classes in a Java package to the global namespace.
#
def importClasses(pn):
	debug("Importing classes from Java package " + pn)
	# Get all defined symbols in the package
	temp = __import__(pn, globals(), locals(), ['*'], -1)
	# Loop over all items in the Java package
	for itemName in dir(temp):
		# Is this the name of a class?
		if itemName[0].isupper():
			# Import the class by defining it as a global variable
			exec("global " + itemName + "\n" + itemName + " = eval('temp.' + itemName)")
			
#
# Enable the task package and import all its packages.
#
def enableTaskPackage(name):
	debug("Enabling task package " + name)
	tp = TaskPackageManager.get().getTaskPackage(name)
	tp.enable()
	
	itr = tp.getJavaPackageNames().iterator()
	while itr.hasNext():
		pn = itr.next()
		importClasses(pn)
		
#
# START HERE
#

# Import dependencies
from org.schmant.report import ReportManager

importClasses("java.io")
importClasses("java.util")
importClasses("java.util.logging")

importClasses("org.entityfs")
importClasses("org.entityfs.el")
importClasses("org.entityfs.entityattrs.unix")
importClasses("org.entityfs.fs")
importClasses("org.entityfs.lock")
importClasses("org.entityfs.ostrat")
importClasses("org.entityfs.support.util")
importClasses("org.entityfs.support.util.regexp")
importClasses("org.entityfs.util")
importClasses("org.entityfs.util.cap.entity")
importClasses("org.entityfs.util.filter")
importClasses("org.entityfs.util.filter.entity")
importClasses("org.entityfs.util.filter.regexp")
importClasses("org.entityfs.util.itr")
importClasses("org.entityfs.util.properties")
importClasses("org.entityfs.util.zip")

importClasses("org.schmant")
importClasses("org.schmant.arg")
importClasses("org.schmant.lang")
importClasses("org.schmant.project")
importClasses("org.schmant.project.eclipse")
importClasses("org.schmant.project.filter")
importClasses("org.schmant.project.intellij")
importClasses("org.schmant.project.java")
importClasses("org.schmant.report")
importClasses("org.schmant.run")
importClasses("org.schmant.support")
importClasses("org.schmant.support.entityfs")
importClasses("org.schmant.support.io")
importClasses("org.schmant.support.text")
importClasses("org.schmant.support.xml")
importClasses("org.schmant.task")
importClasses("org.schmant.task.template.jdk.javadoc")
importClasses("org.schmant.tpm")

debug("In prepare.py")

enableTaskPackage("org.schmant.task.base")
